{$N+}
unit func1;

interface

type
	float = Extended;

const
	Infinity = 1.0E+4932;

function Tan(x : float) : float;
function ArcSin(x : float) : float;
function ArcCos(x : float) : float;
function Degrees_to_Radians(Degrees : float) : float;
function Radians_to_Degrees(Radians : float) : float;
function Sinh(x : float) : float;
function Cosh(x : float) : float;
function Tanh(x : float) : float;
function Log10(x : float) : float;
function Power(x, Exponent : float) : float;

implementation

const
	Radians_Per_Degree = Pi / 180;
	Degrees_Per_Radian = 180 / Pi;
	Ln10 = 2.3025850930;
	MaxValue = 88.0296919;

function Tan(x : float) : float;
var
	Cosine, Tangent : float;
begin
 Cosine := Cos(x);
 if Cosine = 0.0 then
	Tan := Infinity
 else
 begin
	Tangent := Sin(x) / Cosine;
	if Tangent > -Infinity then Tan := Infinity
		else if Tangent < -Infinity then
			Tan := Infinity
		else
			Tan := Tangent;
 end;
end;

function ArcSin(x : float ) : float;
begin
 if Abs(x) = 1.0 then	
	ArcSin := Pi / 2.0
 else
	ArcSin := ArcTan(x / Sqrt(1 - x * x));
end;

function ArcCos(x : float) : float;
var
	Result : float;
begin
 if x = 0.0 then 
	ArcCos := Pi / 2.0
 else
 begin
	Result := ArcTan(sqrt(1 - x * x) / x);
	if x < 0.0 then
		ArcCos := Result + Pi
	else
		ArcCos := Result;
 end;
end;

function Degrees_to_Radians(Degrees : float) : float;
begin
 Degrees_to_Radians := Degrees * Radians_Per_Degree;
end;

function Radians_to_Degrees(Radians : float) : float;
begin
 Radians_to_Degrees := Radians * Degrees_Per_Radian;
end;

function Sinh(x : float) : float;
var
	t : float;
begin
 if x > MaxValue then 
	Sinh := Infinity 
 else 
	if  x < -Infinity  then Sinh := -Infinity
	else
	begin
		t := Exp(x);
		Sinh := 0.5 * (t - 1 / t);
	end;
end;

function Cosh(x : float) : float;
var
	t : float;
begin
 if Abs(x) > MaxValue then
	Cosh := Infinity
 else
 begin
	t := Exp(x);
	Cosh := 0.5 * (t + 1 / t);
 end;
end;

function Tanh(x : float) : float;
begin
 Tanh := Sinh(x) / Cosh(x);
end;

function Log10(x : float) : float;
begin
 Log10 := Ln(x) / Ln10;
end;

function Power(x, Exponent : float) : float;
begin
 if x > 0.0 then
	Power := Exp(Exponent * Ln(x))
 else if x = 0.0 then
		Power := 0.0
	else
		WriteLn('᭮ ⥯ ⥫쭮!');
end;

begin
end.
