{$S+}
unit  bin_tree;

interface

uses crt;

type
	binary_tree = ^node;
	node = record
		key : Integer;
		data : Pointer;
		left, right, parent : binary_tree;
	end;

procedure create_tree(var  b : binary_tree);
procedure destroy_tree(var  b : binary_tree);
function search(k : Integer; b : binary_tree) : binary_tree;
function min_node(b : binary_tree) : binary_tree;
function successor(b: binary_tree): binary_tree;
function height(b : binary_tree) : Word;
procedure insert(n : node;  var  b : binary_tree);
procedure remove(nptr : binary_tree; var b : binary_tree);

implementation

procedure  create_tree(var b : binary_tree);
begin
 New(b);
 with  b^  do
 begin
	parent := nil;
	left := nil;  right := nil;
	data := nil;
 end;
end;

procedure  destroy_tree(var  b : binary_tree);
begin
 if  b^.left <> nil  then  destroy_tree(b^.left);
 if  b^.right <> nil  then  destroy_tree(b^.right);
 Dispose(b^.data);
 Dispose(b);  
 b := nil;
end;

function  search(k : Integer;  b : binary_tree) :  binary_tree;
begin
 while  (b <> nil) and (k <> b^.key)  do
	if  k < b^.key  then  
		b := b^.left
	else  
		b := b^.right;
end;

function  min_node(b : binary_tree) : binary_tree;
begin
 while  b^.left <> nil  do  
	b := b^.left;
 min_node := b;
end;

function  height(b : binary_tree) : Word;

var
	j, k : Word;

begin
 if  b = nil  then  
	height := 0
 else
 begin
	j := height(b^.left);
	k := height(b^.right);
	if  j > k  then  
		height := 1 + j
	else  
		height := 1 + k;
 end;
end;

procedure  insert(n : node;  var  b : binary_tree);

var
	run, prev : binary_tree;

begin
 if  b = nil  then
 begin
	create_tree(b);
	b^ := n;
 end
 else
 begin
	prev := nil;
	run := b;
	while  run <> nil  do
	begin
		prev := run;
		if  n.key < run^.key  then  
			run :=  run^.left
		else  
			run := run^.right;
	end;
	n.parent := prev;
	if  n.key < prev^.key  then
	begin
		create_tree(prev^.left);
		prev^.left^ := n;
	end
	else
	begin
		create_tree(prev^.right);
		prev^.right^ := n;
	end;
 end;
end;

function  successor(b: binary_tree): binary_tree;

var
	c: binary_tree;

begin
 if  b^.right <> nil  then
	successor := min_node(b^.right)
 else
 begin
	c := b^.parent;
	while  (c <> nil) and (b = c^.right)  do
	begin
		b := c;
		c := b^.parent;
	end;
	successor := c;
 end;
end;   


procedure  remove(nptr : binary_tree;  var  b : binary_tree);

var
	x, y : binary_tree;

begin
 if  nptr^.left = nil  then
 begin
	if  nptr^.right = nil  then
	begin
		x := nptr^.parent;
		if  x = nil  then  
			destroy_tree(b)
		else  
			if  x^.left = nptr  then
				destroy_tree(x^.left)
			else  
				destroy_tree(x^.right);
	end
	else
	begin
		x := nptr^.parent;
		if  x^.left = nptr  then  
			x^.left := nptr^.right
		else  
			x^.right := nptr^.right;
		nptr^.right := nil;
		destroy_tree(nptr);
	end;
 end
 else  
	if  nptr^.right = nil  then
	begin
		x := nptr^.parent;
		if  x^.left = nptr  then  
			x^.left := nptr^.left
		else  
			x^.right := nptr^.left;
		nptr^.left := nil;
		destroy_tree(nptr);
	end
	else
	begin
		y := successor(nptr);
		x := y^.parent;
		if  x^.left = y  then  
			x^.left := y^.right
		else  
			x^.right := y^.right;
		nptr^.data := y^.data;
		y^.right := nil;
		destroy_tree(y);
	end;
end;

end.
