unit dyn_arr;

interface

type
	Vector_type = array[0..65519] of Byte;
	ptrVector = ^Vector_type;
	Matrix_type = array[0..16379] of ptrVector;
	ptrMatrix = ^Matrix_type;
	ptrInteger = ^Integer;
	ptrReal = ^Real;
	typeAndName = String[25];

	vector = object
		ptv : ptrVector;
		nature : Char;
		name : String[24];
		lastCol, size : Word;
		procedure init(tn : typeAndName; col : Word);
		procedure close;
		function intgr(col : Word) : ptrInteger;
		function re(col : Word) : ptrReal;
	end;

	matrix = object
		lastRow, lastCol, size : Word;
		nature : Char;
		name : String[24];
		ptm : ptrMatrix;
		procedure init(tn : typeAndName; row, col : Word);
		procedure close;
		function intgr(row, col : Word) : ptrInteger;
		function re(row, col : Word) : ptrReal;
	end;

implementation

const
	max1= 32759;
	max2= 10919;
	max3= 16379;

type
	intVec = array[0..max1] of Integer;
	realVec = array[0..max2] of Real;

procedure adjustVectorSize(var col : Word; nature : Char; name : String);

var
	max : Word;

begin
 case nature of
	'I' : max := max1;
	'R' : max := max2
 end;
 if col > max then
 begin
	WriteLn;
	WriteLn('  ' + name  + '   ', col, '  ', max);
	col := max
 end
end;

procedure adjustMatrixSize(var col : Word; nature : Char; name : String);

var
	max : Word;

begin
 case nature of
	'I' : max := max1;
	'R' : max := max2;
 end;
 if col > max then
 begin
	WriteLn;
	WriteLn('  ' + name + '   ', col, '  ', max);
	col := max
 end
end;

procedure vector.init(tn : typeAndName; col : Word);
begin
 FillChar(self, sizeOf(self), 0);
 nature := upcase(tn[1]);
 name := copy(tn, 2, length(tn) - 1);
 adjustVectorSize(col, nature, name);
 lastcol := col;
 inc(col);
 case nature of
	'I' : size := SizeOf(intVec);
	'R' : size := SizeOf(realVec);
 else
	WriteLn('訡   ' + name + '  ⨯ ' + nature);
	Halt
 end;
 GetMem(ptv, size);
 FillChar(ptv^, size, 0);
end;

procedure vector.close;
begin
 FreeMem(ptv, size);
 FillChar(self, sizeOf(self), 0);
end;

function vector.intgr(col : Word) : ptrInteger;
begin
 intgr := @intVec(ptv^)[col]
end;

function vector.re(col : Word) : ptrReal;
begin
 re := @realVec(ptv^)[col]
end;

procedure matrix.init(tn : typeAndName; row, col : Word);
begin
 FillChar(self, sizeOf(self), 0);
 nature := UpCase(tn[1]);
 name := Copy(tn, 2, Length(tn) - 1);
 if row > max3 then row := max3;
 lastRow := row;
 adjustMatrixSize(col, nature, name);
 lastCol := col;
 inc(col);
 case nature of
	'I' : size := SizeOf(intVec);
	'R' : size := SizeOf(realVec);
 else
	WriteLn('訡   ' + name + ' ࠢ ⨯ ' + nature);
	Halt
 end;
 GetMem(ptm, (row + 1) * sizeOf(pointer));
 for  row := 0  to  lastRow  do
 begin
	GetMem(ptm^[row], size);
	FillChar(ptm^[row]^, size, 0);
 end
end;

procedure matrix.close;

var
 y : Word;

begin
 inc(lastCol);
 for  y := lastRow  downto  0  do  FreeMem(ptm^[y], size);
 FreeMem(ptm, (lastRow + 1) * sizeOf(pointer));
 FillChar(self, sizeOf(self), 0)
end;

function matrix.intgr(row, col : Word) : ptrinteger;
begin
 intgr := @intVec(ptm^[row]^)[col]
end;

function matrix.re(row, col : Word) : ptrreal;
begin
 re := @realVec(ptm^[row]^)[col]
end;

end.
