program oscillations;

uses crt, Graph, graphs;

var
	amplitude1, frequency1, phase1,
	amplitude2, frequency2, phase2 : Real;

type
	Oscill = object
		amplitude, frequency, phase : Real;
		procedure Init(var amplitude1, frequency1, f1 : Real);
		procedure Draw(time_increment : real; color, y_shift : Integer);
		procedure Draw_Summa(amplitude2, frequency2, phase2, 
			time_increment : Real; color, y_shift : Integer);
		procedure Draw_Product(amplitude2, frequency2, phase2, 
			time_increment : Real; color, y_shift : Integer);
	end;

procedure Oscill.Init(var amplitude1, frequency1, f1 : Real);
begin
 Write('  ᨣ:');
 ReadLn(amplitude);
 Write('  ᨣ:');
 ReadLn(frequency);
 Write(' 䠧 ᨣ:');
 ReadLn(phase);
 amplitude1 := amplitude;
 frequency1 := frequency;
 phase1 := phase;
end;

procedure Oscill.Draw(time_increment : Real; color, y_shift : Integer);
var
	y, time : Real;
begin
 time := 0;
 repeat
	y := amplitude * sin(frequency * time + phase + Pi);
	PutPixel(round(time), round(y + y_shift), color);
	time := time + time_increment;
 until time > 640;
end;

procedure Oscill.Draw_Summa(amplitude2, frequency2, phase2, time_increment : Real; color, y_shift : Integer);
var
	y1, y2, time : Real;
begin
 time := 0;
 repeat
	y1 := amplitude * Sin(frequency * time + phase + Pi);
	y2 := amplitude2 * Sin(frequency2 * time + phase2 + Pi);
	PutPixel(round(time), round(y1 + y2 + y_shift), color);
	time := time + time_increment;
 until time > 640;
end;

procedure Oscill.Draw_Product(amplitude2, frequency2, phase2, 
		time_increment : Real; color, y_shift : Integer);

var
	y1, y2, time, scale : Real;

begin
 time := 0;
 scale := GetMaxY / (amplitude2 * amplitude * 2);
 repeat
	y1 := amplitude * Sin(frequency * time + phase + Pi);
	y2 := amplitude2 * Sin(frequency2 * time + phase2 + Pi);
	PutPixel(round(time), round(scale * y1 * y2 + y_shift), color);
	time := time + time_increment;
 until time > 640;
end;

var
	osc1, osc2 : Oscill;

begin
 osc1.init(amplitude1, frequency1, phase1);
 osc2.init(amplitude2, frequency2, phase2);
 open_graph;
 SetBkColor(11);
 osc1.draw(0.01, 12, 150);
 osc2.draw(0.01, 4, 250);
 ReadLn;
 ClearDevice;
 osc1.draw_summa(amplitude2, frequency2, phase2, 0.01, 5, 240);
 ReadLn;
 ClearDevice;
 osc1.draw_product(amplitude2, frequency2, phase2, 0.01, 5, 240);
 ReadLn;
 close_graph;
end.
